## beads 1.1.13+dfsg

=== CMakeLists.txt ===

# cmake helps to compile "beads"
# please install the cmake package depending on your linux distribution
# and type in the beads root directory :
# cmake .
# make
# make install
cmake_minimum_required(VERSION 2.6)


# The name of our project is "beads".  CMakeLists files in this project can
# refer to the root source directory of the project as ${beads_SOURCE_DIR} and
# to the root binary directory of the project as ${beads_BINARY_DIR}.
PROJECT(beads CXX C)


#message ("compiler : ${CMAKE_CXX_COMPILER} ")


IF ( CMAKE_BASE_NAME MATCHES "cl")
	message ("on est sous Windows")
	SET( WIN32 "true")
ENDIF(CMAKE_BASE_NAME MATCHES "cl")


SET( CMAKE_BUILD_TYPE "Release")
if (NOT CMAKE_INSTALL_PREFIX)
	SET (CMAKE_INSTALL_PREFIX /usr/local)
ENDIF(NOT CMAKE_INSTALL_PREFIX)

IF (CMAKE_INSTALL_PREFIX MATCHES "/usr/local")
	SET( CMAKE_BUILD_TYPE "Debug")
	#SET( CMAKE_BUILD_TYPE "Release")
ENDIF (CMAKE_INSTALL_PREFIX MATCHES "/usr/local")


IF ( CMAKE_BUILD_TYPE MATCHES "Release")
	MESSAGE("compiling as release version")
	ADD_DEFINITIONS("-DQT_NO_DEBUG_OUTPUT")
ELSE ( CMAKE_BUILD_TYPE MATCHES "Release" )
	MESSAGE("compiling as debug version")
ENDIF( CMAKE_BUILD_TYPE MATCHES "Release" )



#SET(WIN32 "true")
#SET(MINGW "true")

set(CMAKE_MODULE_PATH ${beads_SOURCE_DIR}/cmake_modules)
#FIND_PACKAGE ( FindPTHREADS REQUIRED )
#are we using pthreads ?
#IF ( CMAKE_USE_PTHREADS_INIT )
#	INCLUDE_DIRECTORIES ( ${EXPAT_INCLUDE_DIRS} )
#ELSE ( CMAKE_USE_PTHREADS_INIT )
#	MESSAGE( FATAL_ERROR "No pthread installed" )
#ENDIF( CMAKE_USE_PTHREADS_INIT )

#IF ( PTHREADS_FOUND )
	INCLUDE_DIRECTORIES ( ${PTHREADS_INCLUDE_DIR} )
#ELSE ( PTHREADS_FOUND )
#	MESSAGE( FATAL_ERROR "No pthread installed" )
#ENDIF( PTHREADS_FOUND )


cmake_minimum_required(VERSION 2.6)


SET ( EXTRA_CIMG_LIBRARY "")

SET ( CIMG_OS 0)
IF(WIN32)
	SET ( CIMG_OS 2)
	#-O2 -lgdi32
	#SET ( EXTRA_CIMG_LIBRARY "gdi32")
	#SET(CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG")
#	FIND_PACKAGE(FindMagick REQUIRED)
ELSE(WIN32)
	FIND_PACKAGE(Pthreads REQUIRED)
	SET(CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG")
	SET ( CIMG_OS 1)
ENDIF(WIN32)

#
#CMAKE_CXX_FLAGS
SET(CMAKE_CXX_FLAGS_DEBUG "-g")
SET(CMAKE_CXX_FLAGS_MINSIZEREL "-Os -DNDEBUG")
SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -g")

SET (BEADS_VERSION "1.1.13")

SET(CPACK_CMAKE_GENERATOR "Unix Makefiles")
SET(CPACK_GENERATOR "STGZ;TGZ;TZ")
#SET(CPACK_INSTALL_CMAKE_PROJECTS "/tmp;beads;src;/src")
#SET(CPACK_NSIS_DISPLAY_NAME "CMake 2.5")
SET(CPACK_OUTPUT_CONFIG_FILE "./CPackConfig.cmake")
SET(CPACK_PACKAGE_DESCRIPTION_FILE ${beads_SOURCE_DIR}/COPYING)
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "beads is a detection software")
SET(CPACK_PACKAGE_EXECUTABLES "beads")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "beads-${BEADS_VERSION}")
SET(CPACK_PACKAGE_FILE_NAME "beads-${BEADS_VERSION}-Linux-i686")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "beads ${BEADS_VERSION}")
SET(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "beads ${BEADS_VERSION}")
SET(CPACK_PACKAGE_NAME "beads")
SET(CPACK_PACKAGE_VENDOR "CNRS")

IF ( CMAKE_BUILD_TYPE MATCHES "Debug")
	SET (BEADS_VERSION "${BEADS_VERSION}d")
ENDIF( CMAKE_BUILD_TYPE MATCHES "Debug")
SET(CPACK_PACKAGE_VERSION ${BEADS_VERSION})
SET(CPACK_PACKAGE_VERSION_MAJOR "1")
SET(CPACK_PACKAGE_VERSION_MINOR "1")
SET(CPACK_PACKAGE_VERSION_PATCH "13")
SET(CPACK_RESOURCE_FILE_LICENSE ${beads_SOURCE_DIR}/COPYING)
SET(CPACK_RESOURCE_FILE_README ${beads_SOURCE_DIR}/README)
SET(CPACK_RESOURCE_FILE_WELCOME ${beads_SOURCE_DIR}/INSTALL)
SET(CPACK_SOURCE_GENERATOR "TGZ;TZ")
SET(CPACK_SOURCE_OUTPUT_CONFIG_FILE "./CPackSourceConfig.cmake")
SET(CPACK_SOURCE_STRIP_FILES "")
SET(CPACK_STRIP_FILES "bin/beads")
SET(CPACK_SYSTEM_NAME "Linux-i686")
SET(CPACK_TOPLEVEL_TAG "Linux-i686")

SET(CPACK_SOURCE_IGNORE_FILES 
	"moc_.*cxx"
	"/devel_archives/"
	"/figures/"
	"/Soumis/"
	"/samples/"
	"/win32/"
	"/tests/"
	"Makefile"
	"install_manifest.txt"
	"cmake_install.cmake"
	"cmake_install.cmake"
	"CMakeCache.txt"
	"CPackConfig.cmake"
	"CPackSourceConfig.cmake"
	"install_manifest.txt"
	"/CMakeFiles/"
	"/_CPack_Packages/"
	"/Debug/"
	"/Release/"
	"/\\\\.externalToolBuilders/"
	"/\\\\.svn/"
	"/\\\\.settings/"
	"Makefile"
	"\\\\.cdtbuild"
	"\\\\.cdtproject"
	"\\\\.project"
	"\\\\.cproject"
	"beads$"
	".*\\\\.tar\\\\.gz"
)
# cpack -G TGZ --config CPackSourceConfig.cmake
# dpkg-buildpackage -rfakeroot

#.dput.cf
#[olivier-langella]
#fqdn = ppa.launchpad.net
#method = ftp
#incoming = ~olivier-langella/ubuntu/
#login = olivier-langella
#allow_unsigned_uploads = 0
#
#  debuild -S -sa
# dput -f olivier-langella *changes

configure_file (${beads_SOURCE_DIR}/src/config.h.cmake ${beads_SOURCE_DIR}/src/config.h)


SET(CPACK_PACKAGE_EXECUTABLES "beads" "beads")


INCLUDE(CPack)


#INCLUDE(CPack)


SET(CPACK_STRIP_FILES "src/beads;src/qtbeads/qtbeads")


# Recurse into the "src" subdirectories.  This does not actually
# cause another cmake executable to run.  The same process will walk through
# the project's entire directory structure.
SUBDIRS (src)

INSTALL(PROGRAMS src/beads DESTINATION bin)
INSTALL(PROGRAMS src/qtbeads/qtbeads DESTINATION bin)
#INSTALL(DIRECTORY doc/man1 DESTINATION share/man/man1)
INSTALL(FILES doc/man1/beads.1 DESTINATION share/man/man1)
INSTALL(FILES share/applications/beads.desktop DESTINATION share/applications)
INSTALL(FILES share/beads/beads_blue.conf DESTINATION share/beads)
INSTALL(FILES share/beads/beads_silver.conf DESTINATION share/beads)
INSTALL(FILES share/beads/beads_silver_small.conf DESTINATION share/beads)
INSTALL(FILES share/beads/beads_icon.svg DESTINATION share/beads)

=== src/CMakeLists.txt ===

 # this command finds Qt4 libraries and sets all required variables
  # note that it's Qt4, not QT4 or qt4
FIND_PACKAGE( Qt4 REQUIRED )

  
  # add some useful macros and variables
  # (QT_USE_FILE is a variable defined by FIND_PACKAGE( Qt4 ) that contains a path to CMake script)
INCLUDE( ${QT_USE_FILE} )

SET( BEADS_CPP
	beads.cpp
	ConfigFile/ConfigFile
	parameters
	encode/base64
	images/imageIntensity.cpp
	images/imageDirect.cpp
	images/imageCode
	images/imageCoule
	images/imagePaths
	images/imageConfluent
	images/imageProb
	images/parameterProb
	parameterDetection
	images/parameterConfluent
	detection
	images/imageDetection
	images/imageNumber
	images/parameterNumber
	images/imageContours
	spotPROTICdbDocument
	spot
	spotDocument
	spot_document_gnumeric
	spotSvgDocument
	images/imageDeNovo
	CImg
)
IF(WIN32)
ELSE(WIN32)
	FIND_PACKAGE(X11 REQUIRED)
	
	INCLUDE_DIRECTORIES(X11_INCLUDE_DIR)
	# X11_FOUND is true if X11 is available.
	#    * X11_INCLUDE_DIR contains the include directories to use X11.
	#    * X11_LIBRARIES points to the libraries to link against to use X11.
	# Make sure the compiler can find include files from our Hello library.
	include_directories (${X11_INCLUDE_DIR})
	
	ADD_DEFINITIONS(${PTHREADS_DEFINITIONS})
	# -m -pthread FindThreads
	
	# Make sure the linker can find the Hello library once it is built.
	link_directories (${X11_INCLUDE_DIR})
ENDIF(WIN32)


add_executable (beads ${BEADS_CPP})

IF(WIN32)
	 # Link the executable to the Hello library.
	target_link_libraries (beads ${EXTRA_CIMG_LIBRARY} ${QT_LIBRARIES} )
ELSE(WIN32)
	 # Link the executable to the Hello library.
	target_link_libraries (beads ${X11_LIBRARIES} m ${PTHREADS_LIBRARY} ${EXTRA_CIMG_LIBRARY} ${QT_LIBRARIES} )
ENDIF(WIN32)

SUBDIRS (qtbeads)

=== src/qtbeads/CMakeLists.txt ===

 # this command finds Qt4 libraries and sets all required variables
  # note that it's Qt4, not QT4 or qt4
FIND_PACKAGE( Qt4 REQUIRED )

  
  # add some useful macros and variables
  # (QT_USE_FILE is a variable defined by FIND_PACKAGE( Qt4 ) that contains a path to CMake script)
INCLUDE( ${QT_USE_FILE} )

SET( BEADS_FOR_QT_CPP
	../ConfigFile/ConfigFile
	../parameters
	../encode/base64
	../images/imageIntensity.cpp
	../images/imageDirect.cpp
	../images/imageCode
	../images/imageCoule
	../images/imagePaths
	../images/imageConfluent
	../images/imageProb
	../images/parameterProb
	../parameterDetection
	../images/parameterConfluent
	../detection
	../images/imageDetection
	../images/imageNumber
	../images/parameterNumber
	../images/imageContours
	../spotPROTICdbDocument
	../spot
	../spotDocument
	../spot_document_gnumeric
	../spotSvgDocument
	../images/imageDeNovo
	../CImg
)
  
# with SET() command you can change variables or define new ones
  # here we define SAMPLE_SRCS variable that contains a list of all .cpp files
  # note that we don't need \ at the end of line
SET( QTBEADS_SRCS
	qtbeads.cpp
	main_window.cpp
	properties.cpp
	beads_results.cpp
	QCimg.cpp
	q_gel_image.cpp
	q_gel_image_scroll.cpp
#	qtbeads_error.h
)
  
  # another list, this time it includes all header files that should be treated with moc
SET( QTBEADS_MOC_HDRS
	main_window.h
	q_gel_image.h
)  
  # some .ui files
  #SET( SAMPLE_UIS
  #     ./src/ui/Dialog1.ui
  #     ./src/ui/Dialog2.ui
  #)
  
  # and finally an resource file
  #SET( SAMPLE_RCS
  #     ./src/rc/sample.qrc
  #)
  
  # enable warnings
ADD_DEFINITIONS( -Wall )
  
  # by default only QtCore and QtGui modules are enabled
  # other modules must be enabled like this:
 #SET( QT_USE_QT3SUPPORT TRUE )   
 # SET( QT_USE_QTXML TRUE )
    
  
#****************************
#I18N
# Translation files
SET(GLOB TRANS translations/*.ts)
# add translations ...
QT4_ADD_TRANSLATION(QM ${TRANS})



  
#set(CMAKE_MODULE_PATH ${abiftake_SOURCE_DIR}/Modules)
#set(Qwt5_DIR ${abiftake_SOURCE_DIR}/Modules)

#FIND_PACKAGE(Qwt5 REQUIRED) 
  
  
  
  # this command will generate rules that will run rcc on all files from SAMPLE_RCS
  # in result SAMPLE_RC_SRCS variable will contain paths to files produced by rcc
QT4_ADD_RESOURCES( QTBEADS_SRCS ${SAMPLE_RCS} )
  
  # this will run uic on .ui files:
  #QT4_WRAP_UI( SAMPLE_UI_HDRS ${SAMPLE_UIS} )
  
  # and finally this will run moc:
QT4_WRAP_CPP( QTBEADS_MOC_SRCS ${QTBEADS_MOC_HDRS} )
  
  # we need this to be able to include headers produced by uic in our code
  # (CMAKE_BINARY_DIR holds a path to the build directory, while INCLUDE_DIRECTORIES() works just like INCLUDEPATH from qmake)
  #INCLUDE_DIRECTORIES( ${CMAKE_BINARY_DIR} ${Qwt5_INCLUDE_DIR})
INCLUDE_DIRECTORIES( ${CMAKE_BINARY_DIR})
  
  # here we instruct CMake to build "sample" executable from all of the source files
ADD_EXECUTABLE( qtbeads ${BEADS_FOR_QT_CPP} ${QTBEADS_SRCS} ${QTBEADS_MOC_SRCS} ${SAMPLE_RC_SRCS} ${SAMPLE_UI_HDRS} ${QM} )


  # last thing we have to do is to tell CMake what libraries our executable needs,
  # luckily FIND_PACKAGE prepared QT_LIBRARIES variable for us:
  #TARGET_LINK_LIBRARIES( abiftake ${QT_LIBRARIES} ${Qwt5_Qt4_LIBRARY} ${EXTRA_CIMG_LIBRARY})

IF(WIN32)
	TARGET_LINK_LIBRARIES( qtbeads ${QT_LIBRARIES} ${EXTRA_CIMG_LIBRARY})
ELSE(WIN32)
	TARGET_LINK_LIBRARIES( qtbeads ${QT_LIBRARIES} m ${PTHREADS_LIBRARY} ${EXTRA_CIMG_LIBRARY})
ENDIF(WIN32)

=== debian/changelog ===
beads (1.1.13+dfsg-2) unstable; urgency=medium

  * replacing the build dependency on qttools5-dev-tools with qttools5-dev
    Closes: #880850

 -- Andreas Tille <tille@debian.org>  Mon, 06 Nov 2017 00:31:00 +0100

beads (1.1.13+dfsg-1) unstable; urgency=medium

  * Initial upload to Debian (Closes: #879556)

 -- Andreas Tille <tille@debian.org>  Sun, 22 Oct 2017 22:19:26 +0200

=== debian/control ===
Source: beads
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Olivier Langella <olivier.langella@moulon.inra.fr>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake,
               qtbase5-dev,
               qttools5-dev,
               cimg-dev
Standards-Version: 4.1.1
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/beads.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/beads.git
Homepage: http://moulon.inra.fr/beads/beads.html

Package: beads
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         imagemagick
Description: 2-DE electrophoresis gel image spot detection
 BEADS is a program for spot detection on 2-D gel images. It is based on
 an analogy with beads flowing uphill on the surface of the gel image and
 on the analysis of their paths (Langella & Zivy, 2008).

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  http://pappso.inra.fr/bioinfo/beads/index.php .*/downloads/beads-@ANY_VERSION@@ARCHIVE_EXT@

## beads 1.1.18+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,22 +16,20 @@
 
 #message ("compiler : ${CMAKE_CXX_COMPILER} ")
 
-
-IF ( CMAKE_BASE_NAME MATCHES "cl")
-	message ("on est sous Windows")
-	SET( WIN32 "true")
-ENDIF(CMAKE_BASE_NAME MATCHES "cl")
-
-
-SET( CMAKE_BUILD_TYPE "Release")
+SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+
+#IF ( CMAKE_BASE_NAME MATCHES "cl")
+#	message ("on est sous Windows")
+#	SET( WIN32 "true")
+#ENDIF(CMAKE_BASE_NAME MATCHES "cl")
+
+if (NOT CMAKE_BUILD_TYPE)
+  SET( CMAKE_BUILD_TYPE "Release")
+ENDIF(NOT CMAKE_BUILD_TYPE)
+
 if (NOT CMAKE_INSTALL_PREFIX)
 	SET (CMAKE_INSTALL_PREFIX /usr/local)
 ENDIF(NOT CMAKE_INSTALL_PREFIX)
-
-IF (CMAKE_INSTALL_PREFIX MATCHES "/usr/local")
-	SET( CMAKE_BUILD_TYPE "Debug")
-	#SET( CMAKE_BUILD_TYPE "Release")
-ENDIF (CMAKE_INSTALL_PREFIX MATCHES "/usr/local")
 
 
 IF ( CMAKE_BUILD_TYPE MATCHES "Release")
@@ -46,23 +44,14 @@
 #SET(WIN32 "true")
 #SET(MINGW "true")
 
-set(CMAKE_MODULE_PATH ${beads_SOURCE_DIR}/cmake_modules)
-#FIND_PACKAGE ( FindPTHREADS REQUIRED )
-#are we using pthreads ?
-#IF ( CMAKE_USE_PTHREADS_INIT )
-#	INCLUDE_DIRECTORIES ( ${EXPAT_INCLUDE_DIRS} )
-#ELSE ( CMAKE_USE_PTHREADS_INIT )
-#	MESSAGE( FATAL_ERROR "No pthread installed" )
-#ENDIF( CMAKE_USE_PTHREADS_INIT )
+#set(CMAKE_MODULE_PATH ${beads_SOURCE_DIR}/cmake_modules)
 
 #IF ( PTHREADS_FOUND )
-	INCLUDE_DIRECTORIES ( ${PTHREADS_INCLUDE_DIR} )
+#	INCLUDE_DIRECTORIES ( ${PTHREADS_INCLUDE_DIR} )
 #ELSE ( PTHREADS_FOUND )
 #	MESSAGE( FATAL_ERROR "No pthread installed" )
 #ENDIF( PTHREADS_FOUND )
 
-
-cmake_minimum_required(VERSION 2.6)
 
 
 SET ( EXTRA_CIMG_LIBRARY "")
@@ -75,18 +64,18 @@
 	#SET(CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG")
 #	FIND_PACKAGE(FindMagick REQUIRED)
 ELSE(WIN32)
-	FIND_PACKAGE(Pthreads REQUIRED)
-	SET(CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG")
+	#FIND_PACKAGE(Pthreads REQUIRED)
+	SET(CMAKE_CXX_FLAGS_RELEASE "-s -O3 -DNDEBUG")
 	SET ( CIMG_OS 1)
 ENDIF(WIN32)
 
 #
 #CMAKE_CXX_FLAGS
-SET(CMAKE_CXX_FLAGS_DEBUG "-g")
+SET(CMAKE_CXX_FLAGS_DEBUG "-g -s")
 SET(CMAKE_CXX_FLAGS_MINSIZEREL "-Os -DNDEBUG")
 SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -g")
 
-SET (BEADS_VERSION "1.1.13")
+SET (BEADS_VERSION "1.1.18")
 
 SET(CPACK_CMAKE_GENERATOR "Unix Makefiles")
 SET(CPACK_GENERATOR "STGZ;TGZ;TZ")
@@ -109,21 +98,24 @@
 SET(CPACK_PACKAGE_VERSION ${BEADS_VERSION})
 SET(CPACK_PACKAGE_VERSION_MAJOR "1")
 SET(CPACK_PACKAGE_VERSION_MINOR "1")
-SET(CPACK_PACKAGE_VERSION_PATCH "13")
+SET(CPACK_PACKAGE_VERSION_PATCH "15")
 SET(CPACK_RESOURCE_FILE_LICENSE ${beads_SOURCE_DIR}/COPYING)
 SET(CPACK_RESOURCE_FILE_README ${beads_SOURCE_DIR}/README)
 SET(CPACK_RESOURCE_FILE_WELCOME ${beads_SOURCE_DIR}/INSTALL)
 SET(CPACK_SOURCE_GENERATOR "TGZ;TZ")
 SET(CPACK_SOURCE_OUTPUT_CONFIG_FILE "./CPackSourceConfig.cmake")
-SET(CPACK_SOURCE_STRIP_FILES "")
-SET(CPACK_STRIP_FILES "bin/beads")
 SET(CPACK_SYSTEM_NAME "Linux-i686")
 SET(CPACK_TOPLEVEL_TAG "Linux-i686")
 
 SET(CPACK_SOURCE_IGNORE_FILES 
 	"moc_.*cxx"
 	"/devel_archives/"
+	"/build/"
+	"/buildw64/"
+	"/cbuild/"
 	"/figures/"
+	".*\\\\.so"
+	".*\\\\.a"
 	"/Soumis/"
 	"/samples/"
 	"/win32/"
@@ -136,12 +128,13 @@
 	"CPackConfig.cmake"
 	"CPackSourceConfig.cmake"
 	"install_manifest.txt"
+	".gitignore"
 	"/CMakeFiles/"
 	"/_CPack_Packages/"
 	"/Debug/"
 	"/Release/"
 	"/\\\\.externalToolBuilders/"
-	"/\\\\.svn/"
+	"/\\\\.git/"
 	"/\\\\.settings/"
 	"Makefile"
 	"\\\\.cdtbuild"
@@ -165,6 +158,17 @@
 #  debuild -S -sa
 # dput -f olivier-langella *changes
 
+
+
+
+
+#dch -Djessie "message"
+#cmake ..
+#make deb
+# scp beads* proteus.moulon.inra.fr:/var/www/apt/incoming
+# reprepro -Vb /var/www/apt processincoming default
+
+
 configure_file (${beads_SOURCE_DIR}/src/config.h.cmake ${beads_SOURCE_DIR}/src/config.h)
 
 
@@ -177,16 +181,18 @@
 #INCLUDE(CPack)
 
 
-SET(CPACK_STRIP_FILES "src/beads;src/qtbeads/qtbeads")
 
 
 # Recurse into the "src" subdirectories.  This does not actually
 # cause another cmake executable to run.  The same process will walk through
 # the project's entire directory structure.
-SUBDIRS (src)
-
-INSTALL(PROGRAMS src/beads DESTINATION bin)
-INSTALL(PROGRAMS src/qtbeads/qtbeads DESTINATION bin)
+#ADD_DEFINITIONS( -lpthread)
+add_subdirectory (src)
+
+#SET(CPACK_STRIP_FILES "src/beads;src/qtbeads/qtbeads")
+
+INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/src/beads DESTINATION bin)
+INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/src/qtbeads/qtbeads DESTINATION bin)
 #INSTALL(DIRECTORY doc/man1 DESTINATION share/man/man1)
 INSTALL(FILES doc/man1/beads.1 DESTINATION share/man/man1)
 INSTALL(FILES share/applications/beads.desktop DESTINATION share/applications)
@@ -195,3 +201,16 @@
 INSTALL(FILES share/beads/beads_silver_small.conf DESTINATION share/beads)
 INSTALL(FILES share/beads/beads_icon.svg DESTINATION share/beads)
 
+add_custom_target(targz
+	cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz beads-${BEADS_VERSION}.tar.gz
+	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
+	COMMENT "Creating .tar.gz" VERBATIM
+)
+
+
+add_custom_target(deb
+	cd beads-${BEADS_VERSION} && dpkg-buildpackage 
+	DEPENDS targz
+	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
+	COMMENT "Creating Debian package" VERBATIM
+)

=== src/CMakeLists.txt ===

FIND_PACKAGE( Qt5 COMPONENTS Core Gui Xml REQUIRED )

list( APPEND CMAKE_MODULE_PATH
    ${PROJECT_SOURCE_DIR}/cmake_modules
)

set (CImg_INCLUDE_DIR "${CMAKE_SOURCE_DIR}/src/cimg")

if (DEBIAN_PACKAGE)
#  CImg_FOUND - system has CImg lib
    set (CImg_FOUND 1)
#  CImg_INCLUDE_DIRS - the CImg include directory
    set (CImg_INCLUDE_DIR "/usr/include")
#  CImg_SYSTEM_LIBS - external libraries that CImg uses
    set (CImg_SYSTEM_LIBS "/usr/lib${LIB_SUFFIX}/libz.so"
    "/usr/lib${LIB_SUFFIX}/libpng16.so"
    "/usr/lib${LIB_SUFFIX}/libjpeg.so"
    "/usr/lib${LIB_SUFFIX}/libtiff.so")
#  CImg_SYSTEM_LIBS_DIR - external library directories
    set (CImg_SYSTEM_LIBS_DIR "")
#  CImg_CFLAGS - compilation flags
    set (CImg_CFLAGS "pthread" "-Dcimg_use_png" "-Dcimg_use_jpeg" "-Dcimg_use_tiff" "-Dcimg_use_zlib")

else (DEBIAN_PACKAGE)
    find_package( CImg REQUIRED )
endif (DEBIAN_PACKAGE)

# Add CIMG Flags to Compilation Flags
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CIMG_CFLAGS}")

#INCLUDE_DIRECTORIES(${ODSSTREAM_INCLUDE_DIR})

if (MINGW32)
    INCLUDE_DIRECTORIES( ${QUAZIP_INCLUDE_DIR} )
ELSE (MINGW32)
    FIND_PACKAGE( Odsstream REQUIRED )
ENDIF (MINGW32)



SET( BEADS_FOR_QT_CPP
	ConfigFile/ConfigFile
	parameters
	encode/base64
	images/imageIntensity.cpp
	images/imageDirect.cpp
	images/imageCode
	images/imageCoule
	images/imagePaths
	images/imageConfluent
	images/imageProb
	images/parameterProb
	parameterDetection
	images/parameterConfluent
	detection
	images/imageDetection
	images/imageNumber
	images/parameterNumber
	images/imageContours
	spotPROTICdbDocument
	spot
	spotDocument
	spotSvgDocument
	images/imageDeNovo
)

IF(WIN32)
ELSE(WIN32)
	#FIND_PACKAGE(X11 REQUIRED)
	
	#INCLUDE_DIRECTORIES(X11_INCLUDE_DIR)
	# X11_FOUND is true if X11 is available.
	#    * X11_INCLUDE_DIR contains the include directories to use X11.
	#    * X11_LIBRARIES points to the libraries to link against to use X11.
	# Make sure the compiler can find include files from our Hello library.
	#include_directories (${X11_INCLUDE_DIR})
	
	#ADD_DEFINITIONS(${PTHREADS_DEFINITIONS})
	# -m -pthread FindThreads
	
	# Make sure the linker can find the Hello library once it is built.
	#link_directories (${X11_INCLUDE_DIR})
ENDIF(WIN32)


add_executable (beads beads.cpp )
target_include_directories (beads PUBLIC ${ODSSTREAM_INCLUDE_DIR} ${CImg_INCLUDE_DIRS} ${CImg_SYSTEM_LIBS_DIR})
SET_TARGET_PROPERTIES(beads
      PROPERTIES OUTPUT_NAME beads
      CLEAN_DIRECT_OUTPUT 1
      CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CImg_CFLAGS}"
    )

target_link_libraries (beads  cppbeads
        ${ODSSTREAM_QT5_LIBRARY} ${CImg_SYSTEM_LIBS} ${CImg_CFLAGS} Qt5::Core Qt5::Gui Qt5::Xml)


add_library ( cppbeads STATIC
		${BEADS_FOR_QT_CPP}
)

target_include_directories (cppbeads PUBLIC ${ODSSTREAM_INCLUDE_DIR}
    ${CImg_INCLUDE_DIRS} ${CImg_SYSTEM_LIBS_DIR})
SET_TARGET_PROPERTIES(cppbeads
      PROPERTIES OUTPUT_NAME cppbeads-qt5
      CLEAN_DIRECT_OUTPUT 1
      CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CImg_CFLAGS}"
)
target_link_libraries (cppbeads
        ${ODSSTREAM_QT5_LIBRARY} ${CImg_SYSTEM_LIBS} ${CImg_CFLAGS} Qt5::Core Qt5::Gui Qt5::Xml)

    
SUBDIRS (qtbeads)

=== src/qtbeads/CMakeLists.txt ===

FIND_PACKAGE( Qt5 COMPONENTS Core Gui Xml Widgets PrintSupport REQUIRED )
  
  # add some useful macros and variables
  # (QT_USE_FILE is a variable defined by FIND_PACKAGE( Qt4 ) that contains a path to CMake script)
#INCLUDE( ${QT_USE_FILE} )
  
# with SET() command you can change variables or define new ones
  # here we define SAMPLE_SRCS variable that contains a list of all .cpp files
  # note that we don't need \ at the end of line
SET( QTBEADS_SRCS
	qtbeads.cpp
	main_window.cpp
	properties.cpp
	beads_results.cpp
	QCimg.cpp
	q_gel_image.cpp
	q_gel_image_scroll.cpp
#	qtbeads_error.h
)
  
  # another list, this time it includes all header files that should be treated with moc
SET( QTBEADS_MOC_HDRS
	main_window.h
	q_gel_image.h
)  
  # some .ui files
  #SET( SAMPLE_UIS
  #     ./src/ui/Dialog1.ui
  #     ./src/ui/Dialog2.ui
  #)
  
  # and finally an resource file
  #SET( SAMPLE_RCS
  #     ./src/rc/sample.qrc
  #)
  
  # enable warnings
#ADD_DEFINITIONS( -Wall )
  
  # by default only QtCore and QtGui modules are enabled
  # other modules must be enabled like this:
 #SET( QT_USE_QT3SUPPORT TRUE )   
 # SET( QT_USE_QTXML TRUE )

  
  
  
  # this command will generate rules that will run rcc on all files from SAMPLE_RCS
  # in result SAMPLE_RC_SRCS variable will contain paths to files produced by rcc
QT5_ADD_RESOURCES( QTBEADS_SRCS ${SAMPLE_RCS} )
  
  # this will run uic on .ui files:
  #QT4_WRAP_UI( SAMPLE_UI_HDRS ${SAMPLE_UIS} )
  
  # and finally this will run moc:
QT5_WRAP_CPP( QTBEADS_MOC_SRCS ${QTBEADS_MOC_HDRS} )
  
  # we need this to be able to include headers produced by uic in our code
  # (CMAKE_BINARY_DIR holds a path to the build directory, while INCLUDE_DIRECTORIES() works just like INCLUDEPATH from qmake)
  #INCLUDE_DIRECTORIES( ${CMAKE_BINARY_DIR} ${Qwt5_INCLUDE_DIR})


  
  # here we instruct CMake to build "sample" executable from all of the source files
ADD_EXECUTABLE( qtbeads ${QTBEADS_SRCS} ${QTBEADS_MOC_SRCS} ${SAMPLE_RC_SRCS} ${SAMPLE_UI_HDRS} ${QM} )

target_include_directories (qtbeads PUBLIC ${CMAKE_BINARY_DIR} ${ODSSTREAM_INCLUDE_DIR} 
     ${CImg_INCLUDE_DIRS})
    

IF(WIN32)
    SET_TARGET_PROPERTIES(qtbeads
        PROPERTIES 
        LINK_FLAGS "-Wl,--subsystem,windows ${ADD_MINGW_EXE_LINKER_FLAGS}"
        CLEAN_DIRECT_OUTPUT 1
        CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CImg_CFLAGS} ${QT_QTCORE_EXECUTABLE_COMPILE_FLAGS}"
    )
ELSE(WIN32)
    SET_TARGET_PROPERTIES(qtbeads
        PROPERTIES
        CLEAN_DIRECT_OUTPUT 1
        CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CImg_CFLAGS}"
    )
ENDIF(WIN32)

target_link_libraries (qtbeads cppbeads ${ODSSTREAM_QT5_LIBRARY} ${CImg_SYSTEM_LIBS} Qt5::Core Qt5::Gui Qt5::Xml Qt5::Widgets Qt5::PrintSupport)

=== debian/changelog ===
beads (1.1.18+dfsg-4build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:10:38 +0100

beads (1.1.18+dfsg-4) unstable; urgency=medium

  * Drop unneeded  Build-Depends on libquazip5-headers
    Closes: #945885
  * debhelper-compat 12
  * Standards-Version: 4.4.1
  * Remove patches qt5.patch that are missing from
    debian/patches/series.

 -- Andreas Tille <tille@debian.org>  Sun, 01 Dec 2019 07:54:06 +0100

beads (1.1.18+dfsg-3) unstable; urgency=medium

  * Add libquazip5-headers Build-Depends explicitly which seems to have
    vanished from Depends of some build dependency
    Closes: #924472
  * Standards-Version: 4.3.0

 -- Andreas Tille <tille@debian.org>  Wed, 13 Mar 2019 14:02:07 +0100

beads (1.1.18+dfsg-2) unstable; urgency=medium

  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1
  * Remove trailing whitespace in debian/copyright

 -- Andreas Tille <tille@debian.org>  Sat, 27 Oct 2018 17:41:52 +0200

beads (1.1.18+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Watch file now reports new upstream URLs (not fit for proper download
    yet since some more sophisticated name mangling is needed)
  * Standards-Version: 4.1.3
  * debhelper 11
  * Build-Depends: libodsstream-qt5-dev (>= 0.4.13-2)
  * Drop unused lintian override

 -- Andreas Tille <tille@debian.org>  Mon, 19 Feb 2018 13:27:11 +0100

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,15 @@
            Olivier Langella <olivier.langella@moulon.inra.fr>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                qtbase5-dev,
                qttools5-dev,
+               libodsstream-qt5-dev,
                cimg-dev
-Standards-Version: 4.1.1
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/beads.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/beads.git
+Standards-Version: 4.4.1
+Vcs-Browser: https://salsa.debian.org/med-team/beads
+Vcs-Git: https://salsa.debian.org/med-team/beads.git
 Homepage: http://moulon.inra.fr/beads/beads.html
 
 Package: beads

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CMAKE_EXTRA_FLAGS += -DQ_OS_X11=ON

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

## beads 1.1.20

=== CMakeLists.txt ===

# cmake helps to compile "beads"
# please install the cmake package depending on your linux distribution
# and type in the beads root directory :
# cmake .
# make
# make install
cmake_minimum_required(VERSION 2.6)


# The name of our project is "beads".  CMakeLists files in this project can
# refer to the root source directory of the project as ${beads_SOURCE_DIR} and
# to the root binary directory of the project as ${beads_BINARY_DIR}.
project(beads CXX C)



# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#IF( CMAKE_BASE_NAME MATCHES "cl")
#	message("on est sous Windows")
#	SET( WIN32 "true")
#ENDIF(CMAKE_BASE_NAME MATCHES "cl")

if(NOT CMAKE_BUILD_TYPE)
	set( CMAKE_BUILD_TYPE "Release")
endif(NOT CMAKE_BUILD_TYPE)

if(NOT CMAKE_INSTALL_PREFIX)
	set(CMAKE_INSTALL_PREFIX /usr/local)
endif(NOT CMAKE_INSTALL_PREFIX)


if( CMAKE_BUILD_TYPE MATCHES "Release")
	message("compiling as release version")
	add_definitions("-DQT_NO_DEBUG_OUTPUT")
else( CMAKE_BUILD_TYPE MATCHES "Release" )
	message("compiling as debug version")
endif( CMAKE_BUILD_TYPE MATCHES "Release" )



#SET(WIN32 "true")
#SET(MINGW "true")

#set(CMAKE_MODULE_PATH ${beads_SOURCE_DIR}/cmake_modules)

#IF( PTHREADS_FOUND )
#	INCLUDE_DIRECTORIES( ${PTHREADS_INCLUDE_DIR} )
#ELSE( PTHREADS_FOUND )
#	MESSAGE( FATAL_ERROR "No pthread installed" )
#ENDIF( PTHREADS_FOUND )



set( EXTRA_CIMG_LIBRARY "")

set( CIMG_OS 0)
if(WIN32)
	set( CIMG_OS 2)
	#-O2 -lgdi32
	#SET( EXTRA_CIMG_LIBRARY "gdi32")
	#SET(CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG")
	#	FIND_PACKAGE(FindMagick REQUIRED)
else(WIN32)
	#FIND_PACKAGE(Pthreads REQUIRED)
	set(CMAKE_CXX_FLAGS_RELEASE "-s -O3 -DNDEBUG")
	set( CIMG_OS 1)
endif(WIN32)

#
#CMAKE_CXX_FLAGS
set(CMAKE_CXX_FLAGS_DEBUG "-g -s")
set(CMAKE_CXX_FLAGS_MINSIZEREL "-Os -DNDEBUG")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -g")

set(BEADS_VERSION "1.1.20")
set(VERSION 1.1.20)

set(CPACK_CMAKE_GENERATOR "Unix Makefiles")
set(CPACK_GENERATOR "STGZ;TGZ;TZ")
#SET(CPACK_INSTALL_CMAKE_PROJECTS "/tmp;beads;src;/src")
#SET(CPACK_NSIS_DISPLAY_NAME "CMake 2.5")
set(CPACK_OUTPUT_CONFIG_FILE "./CPackConfig.cmake")
set(CPACK_PACKAGE_DESCRIPTION_FILE ${beads_SOURCE_DIR}/COPYING)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "beads is a detection software")
set(CPACK_PACKAGE_EXECUTABLES "beads")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "beads-${BEADS_VERSION}")
set(CPACK_PACKAGE_FILE_NAME "beads-${BEADS_VERSION}-Linux-i686")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "beads ${BEADS_VERSION}")
set(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "beads ${BEADS_VERSION}")
set(CPACK_PACKAGE_NAME "beads")
set(CPACK_PACKAGE_VENDOR "CNRS")

if( CMAKE_BUILD_TYPE MATCHES "Debug")
	set(BEADS_VERSION "${BEADS_VERSION}d")
endif( CMAKE_BUILD_TYPE MATCHES "Debug")
set(CPACK_PACKAGE_VERSION ${BEADS_VERSION})
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "1")
set(CPACK_PACKAGE_VERSION_PATCH "15")
set(CPACK_RESOURCE_FILE_LICENSE ${beads_SOURCE_DIR}/COPYING)
set(CPACK_RESOURCE_FILE_README ${beads_SOURCE_DIR}/README)
set(CPACK_RESOURCE_FILE_WELCOME ${beads_SOURCE_DIR}/INSTALL)
set(CPACK_SOURCE_GENERATOR "TGZ;TZ")
set(CPACK_SOURCE_OUTPUT_CONFIG_FILE "./CPackSourceConfig.cmake")
set(CPACK_SYSTEM_NAME "Linux-i686")
set(CPACK_TOPLEVEL_TAG "Linux-i686")

set(CPACK_SOURCE_IGNORE_FILES 
	"moc_.*cxx"
	"/devel_archives/"
	"/build/"
	"/buildw64/"
	"/cbuild/"
	"/figures/"
	".*\\\\.so"
	".*\\\\.a"
	"/Soumis/"
	"/samples/"
	"/win32/"
	"/tests/"
	"Makefile"
	"install_manifest.txt"
	"cmake_install.cmake"
	"cmake_install.cmake"
	"CMakeCache.txt"
	"CPackConfig.cmake"
	"CPackSourceConfig.cmake"
	"install_manifest.txt"
	".gitignore"
	"/CMakeFiles/"
	"/_CPack_Packages/"
	"/Debug/"
	"/Release/"
	"/\\\\.externalToolBuilders/"
	"/\\\\.git/"
	"/\\\\.settings/"
	"Makefile"
	"\\\\.cdtbuild"
	"\\\\.cdtproject"
	"\\\\.project"
	"\\\\.cproject"
	"beads$"
	".*\\\\.tar\\\\.gz"
	)
# cpack -G TGZ --config CPackSourceConfig.cmake
# dpkg-buildpackage -rfakeroot

#.dput.cf
#[olivier-langella]
#fqdn = ppa.launchpad.net
#method = ftp
#incoming = ~olivier-langella/ubuntu/
#login = olivier-langella
#allow_unsigned_uploads = 0
#
#  debuild -S -sa
# dput -f olivier-langella *changes





#dch -Djessie "message"
#cmake ..
#make deb
# scp beads* proteus.moulon.inra.fr:/var/www/apt/incoming
# reprepro -Vb /var/www/apt processincoming default


configure_file(${beads_SOURCE_DIR}/src/config.h.cmake ${beads_SOURCE_DIR}/src/config.h)


set(CPACK_PACKAGE_EXECUTABLES "beads" "beads")


include(CPack)


#INCLUDE(CPack)




# Recurse into the "src" subdirectories.  This does not actually
# cause another cmake executable to run.  The same process will walk through
# the project's entire directory structure.
#ADD_DEFINITIONS( -lpthread)
add_subdirectory(src)

#SET(CPACK_STRIP_FILES "src/beads;src/qtbeads/qtbeads")

install(PROGRAMS ${CMAKE_BINARY_DIR}/src/beads DESTINATION bin)
install(PROGRAMS ${CMAKE_BINARY_DIR}/src/qtbeads/qtbeads DESTINATION bin)
#INSTALL(DIRECTORY doc/man1 DESTINATION share/man/man1)
install(FILES doc/man1/beads.1 DESTINATION share/man/man1)
install(FILES share/applications/beads.desktop DESTINATION share/applications)
install(FILES share/beads/beads_blue.conf DESTINATION share/beads)
install(FILES share/beads/beads_silver.conf DESTINATION share/beads)
install(FILES share/beads/beads_silver_small.conf DESTINATION share/beads)
install(FILES share/beads/beads_icon.svg DESTINATION share/beads)

add_custom_target(targz
	cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz beads-${BEADS_VERSION}.tar.gz
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "Creating .tar.gz" VERBATIM
	)


add_custom_target(deb
	cd beads-${BEADS_VERSION} && dpkg-buildpackage 
	DEPENDS targz
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "Creating Debian package" VERBATIM
	)

=== src/CMakeLists.txt ===
find_package( Qt5 COMPONENTS Core Gui Xml REQUIRED )

list( APPEND CMAKE_MODULE_PATH
	${PROJECT_SOURCE_DIR}/cmake_modules
	)

set(CImg_INCLUDE_DIR "${CMAKE_SOURCE_DIR}/src/cimg")

if(DEBIAN_PACKAGE)
	#  CImg_FOUND - system has CImg lib
	set(CImg_FOUND 1)
	#  CImg_INCLUDE_DIRS - the CImg include directory
	set(CImg_INCLUDE_DIR "/usr/include")
	#  CImg_SYSTEM_LIBS - external libraries that CImg uses
	set(CImg_SYSTEM_LIBS "/usr/lib${LIB_SUFFIX}/libz.so"
		"/usr/lib${LIB_SUFFIX}/libpng16.so"
		"/usr/lib${LIB_SUFFIX}/libjpeg.so"
		"/usr/lib${LIB_SUFFIX}/libtiff.so")
	#  CImg_SYSTEM_LIBS_DIR - external library directories
	set(CImg_SYSTEM_LIBS_DIR "")
	#  CImg_CFLAGS - compilation flags
	set(CImg_CFLAGS "pthread" "-Dcimg_use_png" "-Dcimg_use_jpeg" "-Dcimg_use_tiff" "-Dcimg_use_zlib")

else(DEBIAN_PACKAGE)
	find_package( CImg REQUIRED )
endif(DEBIAN_PACKAGE)

# Add CIMG Flags to Compilation Flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CIMG_CFLAGS}")

#include_directories(${OdsStream_INCLUDE_DIRS})

if(MINGW32)
	include_directories( ${QUAZIP_INCLUDE_DIR} )
else(MINGW32)
	find_package( OdsStream REQUIRED )
endif(MINGW32)



set( BEADS_FOR_QT_CPP
	ConfigFile/ConfigFile
	parameters
	encode/base64
	images/imageIntensity.cpp
	images/imageDirect.cpp
	images/imageCode
	images/imageCoule
	images/imagePaths
	images/imageConfluent
	images/imageProb
	images/parameterProb
	parameterDetection
	images/parameterConfluent
	detection
	images/imageDetection
	images/imageNumber
	images/parameterNumber
	images/imageContours
	spotPROTICdbDocument
	spot
	spotDocument
	spotSvgDocument
	images/imageDeNovo
	)

if(WIN32)
else(WIN32)
	#FIND_PACKAGE(X11 REQUIRED)

	#INCLUDE_DIRECTORIES(X11_INCLUDE_DIR)
	# X11_FOUND is true if X11 is available.
	#    * X11_INCLUDE_DIR contains the include directories to use X11.
	#    * X11_LIBRARIES points to the libraries to link against to use X11.
	# Make sure the compiler can find include files from our Hello library.
	#include_directories(${X11_INCLUDE_DIR})

	#ADD_DEFINITIONS(${PTHREADS_DEFINITIONS})
	# -m -pthread FindThreads

	# Make sure the linker can find the Hello library once it is built.
	#link_directories(${X11_INCLUDE_DIR})
endif(WIN32)


add_executable(beads beads.cpp )
target_include_directories(beads PUBLIC $${CImg_INCLUDE_DIRS} ${CImg_SYSTEM_LIBS_DIR})
set_target_properties(beads
	PROPERTIES OUTPUT_NAME beads
	CLEAN_DIRECT_OUTPUT 1
	CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CImg_CFLAGS}"
	)

target_link_libraries(beads  cppbeads
	${CImg_SYSTEM_LIBS}
	${CImg_CFLAGS}
	Qt5::Core
	Qt5::Gui
	Qt5::Xml
	OdsStream::Core
	)


add_library( cppbeads STATIC
	${BEADS_FOR_QT_CPP}
	)

target_include_directories(cppbeads PUBLIC ${OdsStream_INCLUDE_DIRS}
	${CImg_INCLUDE_DIRS} ${CImg_SYSTEM_LIBS_DIR})
set_target_properties(cppbeads
	PROPERTIES OUTPUT_NAME cppbeads-qt5
	CLEAN_DIRECT_OUTPUT 1
	CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CImg_CFLAGS}"
	)

target_link_libraries(cppbeads
	${CImg_SYSTEM_LIBS}
	${CImg_CFLAGS}
	Qt5::Core
	Qt5::Gui
	Qt5::Xml
	OdsStream::Core
	)


subdirs(qtbeads)

=== src/qtbeads/CMakeLists.txt ===

find_package( Qt5 COMPONENTS Core Gui Xml Widgets PrintSupport REQUIRED )

# add some useful macros and variables
# (QT_USE_FILE is a variable defined by FIND_PACKAGE( Qt4 ) that contains a path to CMake script)
#INCLUDE( ${QT_USE_FILE} )

# with SET() command you can change variables or define new ones
# here we define SAMPLE_SRCS variable that contains a list of all .cpp files
# note that we don't need \ at the end of line
set( QTBEADS_SRCS
	qtbeads.cpp
	main_window.cpp
	properties.cpp
	beads_results.cpp
	QCimg.cpp
	q_gel_image.cpp
	q_gel_image_scroll.cpp
	#	qtbeads_error.h
	)

# another list, this time it includes all header files that should be treated with moc
set( QTBEADS_MOC_HDRS
	main_window.h
	q_gel_image.h
	)  
# some .ui files
#SET( SAMPLE_UIS
#     ./src/ui/Dialog1.ui
#     ./src/ui/Dialog2.ui
#)

# and finally an resource file
#SET( SAMPLE_RCS
#     ./src/rc/sample.qrc
#)

# enable warnings
#ADD_DEFINITIONS( -Wall )

# by default only QtCore and QtGui modules are enabled
# other modules must be enabled like this:
#SET( QT_USE_QT3SUPPORT TRUE )   
# SET( QT_USE_QTXML TRUE )




# this command will generate rules that will run rcc on all files from SAMPLE_RCS
# in result SAMPLE_RC_SRCS variable will contain paths to files produced by rcc
qt5_add_resources( QTBEADS_SRCS ${SAMPLE_RCS} )

# this will run uic on .ui files:
#QT4_WRAP_UI( SAMPLE_UI_HDRS ${SAMPLE_UIS} )

# and finally this will run moc:
qt5_wrap_cpp( QTBEADS_MOC_SRCS ${QTBEADS_MOC_HDRS} )

# we need this to be able to include headers produced by uic in our code
# (CMAKE_BINARY_DIR holds a path to the build directory, while INCLUDE_DIRECTORIES() works just like INCLUDEPATH from qmake)
#INCLUDE_DIRECTORIES( ${CMAKE_BINARY_DIR} ${Qwt5_INCLUDE_DIR})



# here we instruct CMake to build "sample" executable from all of the source files
add_executable( qtbeads ${QTBEADS_SRCS} ${QTBEADS_MOC_SRCS} ${SAMPLE_RC_SRCS} ${SAMPLE_UI_HDRS} ${QM} )

target_include_directories(qtbeads PUBLIC ${CMAKE_BINARY_DIR}
	${OdsStream_INCLUDE_DIRS} 
	${CImg_INCLUDE_DIRS})


if(WIN32)
	set_target_properties(qtbeads
		PROPERTIES 
		LINK_FLAGS "-Wl,--subsystem,windows ${ADD_MINGW_EXE_LINKER_FLAGS}"
		CLEAN_DIRECT_OUTPUT 1
		CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CImg_CFLAGS} ${QT_QTCORE_EXECUTABLE_COMPILE_FLAGS}"
		)
else(WIN32)
	set_target_properties(qtbeads
		PROPERTIES
		CLEAN_DIRECT_OUTPUT 1
		CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CImg_CFLAGS}"
		)
endif(WIN32)

target_link_libraries(qtbeads cppbeads OdsStream::Core ${CImg_SYSTEM_LIBS} Qt5::Core Qt5::Gui Qt5::Xml Qt5::Widgets Qt5::PrintSupport)

=== debian/changelog ===
beads (1.1.20-3) unstable; urgency=medium

  [ Filippo Rusconi ]
  * Fix the watch file to actually point to the proper destination.

  [ Andreas Tille ]
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 07 Nov 2021 10:15:36 +0100

beads (1.1.20-2) unstable; urgency=medium

  [ Nilesh Patra ]
  * Team Upload.
  * Add autopkgtests.
  * compat version: 13
  * Add "Rules-Requires-Root:no"
  * Fix spellings

  [ Andreas Tille ]
  * Add salsa-ci file (routine-update)

 -- Nilesh Patra <npatra974@gmail.com>  Fri, 26 Jun 2020 21:06:34 +0530

beads (1.1.20-1) unstable; urgency=low

  * New upstream version, merging upstream and Debian packaging
    development with the initial work of Andreas Tille, the ongoing
    work by Olivier Langella and Filippo Rusconi.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 06 May 2020 11:04:30 +0200

beads (1.1.19+dfsg-1) unstable; urgency=low

  * New version updating the CMake build system to match
    the changes operated in the libodsstream package
    (closes: #959637) and the name of the libodsstream-dev
    package name. Thanks a lot to Lucas Nussbaum
    <lucas@debian.org> and Andreas Tille
    <andreas@an3as.eu> for reporting the problem.

  * Standards-Version: 4.5.0 (no changes needed).

  * Changed the inra.fr to inrae.fr domain name of the home page.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 05 May 2020 20:08:31 +0200

beads (1.1.18-9) buster; urgency=medium

  * new lib PAPPSOms++

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sat, 11 Apr 2020 11:13:23 +0200

beads (1.1.18-8) stretch; urgency=medium

  * new odsstream library

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 02 Jan 2019 22:14:14 +0100

beads (1.1.18-6) stretch; urgency=medium

  * new pappso mspp library

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 12 Dec 2018 19:20:48 +0100

beads (1.1.18-5) stretch; urgency=medium

  * new libodsstream library

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 16 Aug 2018 10:52:49 +0200

beads (1.1.18-4) stretch; urgency=medium

  * new libodsstream library

 -- Olivier Langella <olivier.langella@u-psud.fr>  Wed, 16 May 2018 09:35:46 +0200

beads (1.1.18-3) stretch; urgency=medium

  * new libodsstream

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 30 Apr 2018 15:43:46 +0200

beads (1.1.18-2) stretch; urgency=medium

  * new libodsstream

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sat, 14 Apr 2018 21:26:00 +0200

beads (1.1.18-1) stretch; urgency=medium

  * better debian package, new libodsstream

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 13 Mar 2018 15:53:00 +0100

beads (1.1.17-2) stretch; urgency=medium

  * better debian package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 16 Feb 2018 06:57:23 +0100

beads (1.1.17-1) stretch; urgency=medium

  * move to QT5

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sun, 11 Feb 2018 18:41:58 +0100

beads (1.1.16-3) stretch; urgency=medium

  * stretch package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 17 Aug 2017 21:41:50 +0200

beads (1.1.16-2) jessie; urgency=medium

  * new odsstream library

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Tue, 23 May 2017 22:31:11 +0200

beads (1.1.16-1) jessie; urgency=medium

  * updated version using libodsstream, better exports

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Mon, 24 Apr 2017 09:42:19 +0200

beads (1.1.15-2) jessie; urgency=medium

  * package for Jessie

 -- Olivier Langella <Olivier.Langella@moulon.inra.fr>  Fri, 28 Aug 2015 16:02:53 +0200

beads (1.1.15-1) wheezy; urgency=low

  * bug fixed creating new beads.conf file

 -- Olivier Langella <olivier.langella@moulon.inra.fr>  Sat, 19 May 2012 06:18:51 +0200

beads (1.1.14-2) natty; urgency=low

  * no more X11 dependency
  * no more pthread depency

 -- Olivier Langella <olivier.langella@moulon.inra.fr>  Sat, 25 Jun 2011 06:18:51 +0200

beads (1.1.14-1~maverick1) maverick; urgency=low

  * new CMakeLists.txt compilation method
  * new Cimg library 1.4.4

 --  Olivier Langella <Olivier.Langella@moulon.inra.fr>  Tue, 02 Nov 2010 10:18:51 +0200

beads (1.1.13-1~maverick1) maverick; urgency=low

  * maverick package

 --  Olivier Langella <Olivier.Langella@moulon.inra.fr>  Thu, 9 Sep 2010 10:18:51 +0200

beads (1.1.13-1~lucid1) lucid; urgency=low

  * fixed bug when trying to save results from sypro images (detected by T. Balliau)

 --  Olivier Langella <Olivier.Langella@moulon.inra.fr>  Thu, 9 Sep 2010 10:18:51 +0200

beads (1.1.12-1~lucid1) lucid; urgency=low

  * command line output extension detection problem fixed
  * integration of Cimg 1.3.9
  * memory leak fixed on qt properties object

 --  Olivier Langella <Olivier.Langella@moulon.inra.fr>  Thu, 26 Aug 2010 10:18:51 +0200

beads (1.1.11-1~lucid1) lucid; urgency=low

  * UTF8 image file path
  * parameter "atom" renamed in "minbeads"
  * rename CONFLUENTS image to SELECT image
  * parameter "minconfl" renamed in "minpath"
  * parameter "flux" renamed in "minflux"
  * confluent_ prefix removed from 	minflux, minpath, winconfl, minbeads
  * prob_ prefix removed from sx, sy, sx_bottom, sy_bottom
  * rename detection_threshold to minproba
  * rename quantification_npass to npass
  * inverse image checked by default

 --  Olivier Langella <Olivier.Langella@moulon.inra.fr>  Tue, 18 May 2010 10:18:51 +0200

beads (1.1.10-1~lucid1) lucid; urgency=low

  * write matchset with matched spot num

 --  Olivier Langella <Olivier.Langella@moulon.inra.fr>  Sat, 10 Apr 2010 10:18:51 +0200

beads (1.1.9-2~lucid1) lucid; urgency=low

  * bug fixed writing sample name in PROTICdbML (thanks to Thierry Balliau)

 --  Olivier Langella <Olivier.Langella@moulon.inra.fr>  Wed, 28 Apr 2010 10:18:51 +0200

beads (1.1.9-1~lucid1) karmic; urgency=low

  * edit spot_num dialog
  * new menu item to save all beads steps in one directory (PROBABILITIES, NUMBERS, PATH...)



=== debian/control ===
Source: beads
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Filippo Rusconi <lopippo@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               qtbase5-dev,
               cimg-dev,
               libodsstream-dev
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/beads
Vcs-Git: https://salsa.debian.org/med-team/beads.git
Homepage: http://pappso.inrae.fr/bioinfo/beads
Rules-Requires-Root: no

Package: beads
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         imagemagick
Description: 2-DE electrophoresis gel image spot detection
 Beads is a program for spot detection on 2-D gel images. It is based on
 an analogy with beads flowing uphill on the surface of the gel image and
 on the analysis of their paths (Langella & Zivy, 2008).

=== debian/watch ===
version=4

https://salsa.debian.org/med-team/beads/tags?sort=updated_desc archive/@ANY_VERSION@/beads-\d\S*@ARCHIVE_EXT@

## beads 1.1.22

=== debian/changelog ===
beads (1.1.22-2) unstable; urgency=medium

  * Team upload.

  [ Adrian Bunk ]
  * Fix FTBFS with CMake 4. Closes: #1112754.

  [ Santiago Vila ]
  * d/control: Drop "Rules-Requires-Root: no" (default).
  * d/control: Update standards-version.
  * d/salsa-ci.yml: Use the simplified version.

 -- Santiago Vila <sanvila@debian.org>  Mon, 13 Oct 2025 20:15:00 +0200

beads (1.1.22-1) unstable; urgency=low

  * New upstream version hopefully fixing bug (Closes: #1027544), thanks to
    Lucas Nussbaum for the bug report (note the that the unfixed software
    builds fine in a sid chroot on my computer).

 -- Filippo Rusconi <lopippo@debian.org>  Sun, 01 Jan 2023 19:52:38 +0100

beads (1.1.21-1) unstable; urgency=low

  * Port to Qt6. 
  * Update version of libodsstream-dev build-dep package.
  * Fixes in the CMake-based system.
  * Standards-Version: 4.6.1 (routine update).

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 14 Dec 2022 12:45:41 +0100

beads (1.1.20-4) UNRELEASED; urgency=low

  [ Filippo Rusconi ]
  * Rewrite the watch file so that it points to the actual development
    repository site (beads had erroneously a full source repos in salsa).

 -- Filippo Rusconi <lopippo@debian.org>  Sun, 07 Nov 2021 13:18:21 +0100

beads (1.1.20-2~buster3) buster; urgency=medium

  * new libpappsoms++ library

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 23 Jul 2020 13:21:24 +0200

beads (1.1.20-2~buster2) buster; urgency=medium

  * new libpappsoms++ library

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 23 Jul 2020 10:04:49 +0200

beads (1.1.20-2~buster1) buster; urgency=medium

  * new debian package for Debian 10 Buster based on Filippo's version

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 18 May 2020 10:44:24 +0200

=== debian/control ===
Source: beads
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Filippo Rusconi <lopippo@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
 cmake,
 qtbase5-dev,
 cimg-dev,
 libodsstream-dev (>= 0.9.1),
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/beads
Vcs-Git: https://salsa.debian.org/med-team/beads.git
Homepage: http://pappso.inrae.fr/bioinfo/beads

Package: beads
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 imagemagick,
Description: 2-DE electrophoresis gel image spot detection
 Beads is a program for spot detection on 2-D gel images. It is based on
 an analogy with beads flowing uphill on the surface of the gel image and
 on the analysis of their paths (Langella & Zivy, 2008).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_build:
	sed -i 's/assignement/assignment/' src/cimg/CImg.h
	dh_auto_build
